<?php
/* Autor...:  */
/* Esquema.: ALM_CajaChicaLog.xml */
/* Generado: 2020-08-18 04:21:23 */

/* Metodos de acceso a los campos de la tabla ALM_CajaChicaLog */
abstract class BaseALM_CajaChicaLogBN
{
    /* Campos de la tabla */
    private $i_IdCajaLog;    // IdCajaLog: ( no definido )
    private $i_IdCaja;    // IdCaja: ( no definido )
    private $i_TipoLog;    // TipoLog: ( no definido )
    private $s_ValorAnterior;    // ValorAnterior: ( no definido )
    private $s_ValorNuevo;    // ValorNuevo: ( no definido )
    private $d_FechaCreacion;    // FechaCreacion: ( no definido )
    private $s_UsuarioCreacion;    // UsuarioCreacion: ( no definido )

    /* Establece el valor del campo IdCajaLog */
    public function setIdCajaLog( $i_IdCajaLog )
    {
        $this->i_IdCajaLog = $i_IdCajaLog;
    }

    /* Obtiene el valor del campo IdCajaLog */
    public function getIdCajaLog()
    {
        return $this->i_IdCajaLog;
    }

    /* Establece el valor del campo IdCaja */
    public function setIdCaja( $i_IdCaja )
    {
        $this->i_IdCaja = $i_IdCaja;
    }

    /* Obtiene el valor del campo IdCaja */
    public function getIdCaja()
    {
        return $this->i_IdCaja;
    }

    /* Establece el valor del campo TipoLog */
    public function setTipoLog( $i_TipoLog )
    {
        $this->i_TipoLog = $i_TipoLog;
    }

    /* Obtiene el valor del campo TipoLog */
    public function getTipoLog()
    {
        return $this->i_TipoLog;
    }

    /* Establece el valor del campo ValorAnterior */
    public function setValorAnterior( $s_ValorAnterior )
    {
        $this->s_ValorAnterior = $s_ValorAnterior;
    }

    /* Obtiene el valor del campo ValorAnterior */
    public function getValorAnterior()
    {
        return $this->s_ValorAnterior;
    }

    /* Establece el valor del campo ValorNuevo */
    public function setValorNuevo( $s_ValorNuevo )
    {
        $this->s_ValorNuevo = $s_ValorNuevo;
    }

    /* Obtiene el valor del campo ValorNuevo */
    public function getValorNuevo()
    {
        return $this->s_ValorNuevo;
    }

    /* Establece el valor del campo FechaCreacion */
    public function setFechaCreacion( $d_FechaCreacion )
    {
        $this->d_FechaCreacion = $d_FechaCreacion;
    }

    /* Obtiene el valor del campo FechaCreacion */
    public function getFechaCreacion()
    {
        return $this->d_FechaCreacion;
    }

    /* Establece el valor del campo UsuarioCreacion */
    public function setUsuarioCreacion( $s_UsuarioCreacion )
    {
        $this->s_UsuarioCreacion = $s_UsuarioCreacion;
    }

    /* Obtiene el valor del campo UsuarioCreacion */
    public function getUsuarioCreacion()
    {
        return $this->s_UsuarioCreacion;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'IdCajaLog' => $this->getIdCajaLog(),
            'IdCaja' => $this->getIdCaja(),
            'TipoLog' => $this->getTipoLog(),
            'ValorAnterior' => $this->getValorAnterior(),
            'ValorNuevo' => $this->getValorNuevo(),
            'FechaCreacion' => $this->getFechaCreacion(),
            'UsuarioCreacion' => $this->getUsuarioCreacion(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto ALM_CajaChicaLogBN desde un RecordSet */
    public static function retrieveByRs( $o_ALM_CajaChicaLogRs )
    {
        $o_ALM_CajaChicaLogBN = new ALM_CajaChicaLogBN();
        $o_ALM_CajaChicaLogBN->setIdCajaLog( ( integer ) $o_ALM_CajaChicaLogRs[ "IdCajaLog" ] );
        $o_ALM_CajaChicaLogBN->setIdCaja( ( integer ) $o_ALM_CajaChicaLogRs[ "IdCaja" ] );
        $o_ALM_CajaChicaLogBN->setTipoLog( ( integer ) $o_ALM_CajaChicaLogRs[ "TipoLog" ] );
        $o_ALM_CajaChicaLogBN->setValorAnterior( $o_ALM_CajaChicaLogRs[ "ValorAnterior" ] );
        $o_ALM_CajaChicaLogBN->setValorNuevo( $o_ALM_CajaChicaLogRs[ "ValorNuevo" ] );
        $o_ALM_CajaChicaLogBN->setFechaCreacion( utilTimestamp::getTimestamp( $o_ALM_CajaChicaLogRs[ "FechaCreacion" ], "Y-m-d H:i:s" ) );
        $o_ALM_CajaChicaLogBN->setUsuarioCreacion( $o_ALM_CajaChicaLogRs[ "UsuarioCreacion" ] );
        return $o_ALM_CajaChicaLogBN;
    }
}
?>